module.exports = {
  parser: "@typescript-eslint/parser",
  globals: { Atomics: "readonly", SharedArrayBuffer: "readonly" },
  parserOptions: {
    project: "./tsconfig.json",
    tsconfigRootDir: __dirname,
    sourceType: "module",
    parser: "@typescript-eslint/parser",
    ecmaVersion: 2021,
  },
  plugins: ["import", "prettier", "@typescript-eslint", "@typescript-eslint/eslint-plugin", "simple-import-sort"],
  extends: [
    "plugin:@typescript-eslint/recommended",
    "plugin:prettier/recommended",
    "prettier",
  ],
  root: true,
  env: {
    node: true,
    jest: true,
    es6: true,
  },
  ignorePatterns: [".eslintrc.js"],
  rules: {
    "no-unused-vars": "off",
    "no-trailing-spaces": ["error", { skipBlankLines: true }],
    "no-multiple-empty-lines": "error",
    "no-use-before-define": ["error", { functions: false, classes: false }],
    "newline-after-var": ["error", "always"],
    "quotes": ["error"],
    "semi": ["error", "always"],
    "no-console": ["error"],
    // "indent": ["error", 2],
    "no-debugger": ["warn"],
    //
    "import/no-default-export": ["error"],
    "import/no-unresolved": "off",
    "import/prefer-default-export": "off",
    "import/extensions": "off",
    "import/no-extraneous-dependencies": "off",
    "simple-import-sort/imports": "error",
    "simple-import-sort/exports": "error",
    //
    "@typescript-eslint/interface-name-prefix": "off",
    "@typescript-eslint/semi": [2, "always"],
    "@typescript-eslint/no-unused-vars": ["error"],
    "@typescript-eslint/explicit-function-return-type": "off",
    "@typescript-eslint/explicit-module-boundary-types": "off",
    "@typescript-eslint/no-explicit-any": "off",
  },
};
